#!/usr/bin/perl -w

use strict;

(scalar(@ARGV)==3) or
  die "Need 3 files: <all cycles> <ref cycles> <location cycles>\n";

my ($litmus, $ref, $locations) = @ARGV;

my %all_cycles = ();
open LITMUS,"<$litmus";
while(<LITMUS>)
{
  chomp;
  (/^#/) and next;
  (/^(\S+): (.+)$/) or die "Unexpected cycle format: $_\n";
  defined($all_cycles{$2}) and die "Cycle $2 ($1) already known as $all_cycles{$2}\n";
  $all_cycles{$2}=$1;
}

my @ref_cycles = ();
open REF,"<$ref";
while(<REF>)
{
  chomp;
  push @ref_cycles, $_;
}

my @loc_cycles = ();
open LOCATIONS,"<$locations";
while(<LOCATIONS>)
{
  chomp;
  push @loc_cycles, $_;
}

(scalar(@ref_cycles)==scalar(@loc_cycles)) or
  die "Number of cycles in $ref and $locations don't match\n";

my $i=0;
foreach my $ref (@ref_cycles)
{
  # print "$i\n";
  my @cycle=split(' ', $ref);
  my $found=0;
  for(my $k=0; $k<scalar(@cycle); $k++)
  {
    my $cycle_str=join(' ', @cycle);
    if(defined($all_cycles{$cycle_str}))
    {
      print "Cycle ".($i+1)." is $all_cycles{$cycle_str} on locations $loc_cycles[$i]\n";
      $found=1;
      last;
    }
    push(@cycle, shift(@cycle));
  }
  if(!$found)
  {
    print "No matching litmus test for cycle ".($i+1).": $ref\n";
  }
  $i++;
}

